package sample2;
public final class Sales {
	private final String code;	// 商品コード
	private final String name;	// 商品名
	private final int price;		// 価格
	private final int quantity;	// 個数
	private final boolean stock;	// 在庫
	public Sales(String code, String name,
			int price, int quantity, boolean stock) {
		this.code = code;
		this.name = name;
		this.price = price;
		this.quantity = quantity;
		this.stock = stock;
	}
	/* 機　能  売上額（price×quantity）が500,000以上かどうか調べる
	 * 引　数　なし
	 * 戻り値　500,000以上ならtrueを返し、そうでなければfalseを返す
	 */
	public boolean isHighSalse() {
		return amount()>=500000 ? true : false;
	}
	/* 機　能  売上額（price × quantity）を返す
	 * 引　数　なし
	 * 戻り値　売上額
	 */
	public int amount() {
		return price * quantity;
	}
	public String getCode() {
		return code;
	}
	public String getName() {
		return name;
	}
	public int getPrice() {
		return price;
	}
	public int getQuantity() {
		return quantity;
	}
	public boolean isStock() {
		return stock;
	}
	@Override
	public String toString() {
		return "Salse [code=" + code + ", name=" + name + ", price=" + price + ", quantity=" + quantity + ", stock=" + stock + "]";
	}
}
